Package: org.codehaus.groovy.transform

## [Java] Class EqualsAndHashCodeASTStubber

- org.codehaus.groovy.transform.EqualsAndHashCodeASTStubber

-     @GroovyASTTransformation(phase = CompilePhase.CONVERSION)
      public class EqualsAndHashCodeASTStubber
      extends AbstractASTTransformation

  Joint-compilation stubber for EqualsAndHashCode. Emits placeholder `hashCode()` and `equals(Object)` methods so the `@EqualsAndHashCode`-generated overrides are visible in the joint-compilation stub even though Object already provides them.

  As with ToStringASTStubber, simple call sites compile either way (Object-inherited dispatch is enough), but exposing the declared overrides in the stub matters for Java code that does `super.equals()` / `super.hashCode()` chaining or for tooling that distinguishes declared from inherited methods.

  The placeholder bodies return safe defaults; the full EqualsAndHashCodeASTTransformation at CANONICALIZATION recognises the stubber metadata and replaces the bodies with the real implementations.

  Since:
    6.0.0

- - Inherited fields
    Fields inherited from class | Fields
    --- | ---
    `class AbstractASTTransformation` | `RETENTION_CLASSNODE, sourceUnit`

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `public void` | `visit(ASTNode[] nodes, SourceUnit source)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class AbstractASTTransformation` | `addError, checkIncludeExcludeUndefinedAware, checkIncludeExcludeUndefinedAware, checkNotInterface, checkPropertyList, checkPropertyList, checkPropertyList, copyAnnotatedNodeAnnotations, copyAnnotatedNodeAnnotations, deemedInternal, deemedInternalName, getAnnotationName, getMemberClassList, getMemberClassValue, getMemberClassValue, getMemberIntValue, getMemberStringList, getMemberStringValue, getMemberStringValue, getMemberValue, hasAnnotation, init, markAsInternal, memberHasValue, shouldSkip, shouldSkip, shouldSkip, shouldSkipOnDescriptorUndefinedAware, shouldSkipUndefinedAware, shouldSkipUndefinedAware, shouldSkipUndefinedAware, tokenize`

- - ### Method Detail

    - #### public void visit(ASTNode[] nodes, SourceUnit source)